<?php
/**
 * @package SP Page Builder
 * @author JoomShaper http://www.joomshaper.com
 * @copyright Copyright (c) 2010 - 2020 JoomShaper
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or later
*/
//no direct accees
defined ('_JEXEC') or die ('Restricted access');

class SppagebuilderAddonCustomer_reviews extends SppagebuilderAddons {

	public function render() {
		$settings = $this->addon->settings;

		$class = (isset($settings->class) && $settings->class) ? ' '.$settings->class : '';
        $testimonial_carousel_layout = (isset($settings->testimonial_carousel_layout) && $settings->testimonial_carousel_layout) ? $settings->testimonial_carousel_layout : '';
        $carousel_autoplay = (isset($settings->carousel_autoplay) && $settings->carousel_autoplay) ? $settings->carousel_autoplay : 0;
        $carousel_speed = (isset($settings->carousel_speed) && $settings->carousel_speed) ? $settings->carousel_speed : 1500;
        $carousel_interval = (isset($settings->carousel_interval) && $settings->carousel_interval) ? $settings->carousel_interval : 4500;
        $carousel_margin = (isset($settings->carousel_margin) && $settings->carousel_margin) ? $settings->carousel_margin : 0;
        $carousel_item_number_xxl = (isset($settings->carousel_item_number_original->xxl) && $settings->carousel_item_number_original->xxl) ? $settings->carousel_item_number_original->xxl : 3;
        $carousel_item_number_xl = (isset($settings->carousel_item_number_original->xl) && $settings->carousel_item_number_original->xl) ? $settings->carousel_item_number_original->xl : 3;
        $carousel_item_number_lg = (isset($settings->carousel_item_number_original->lg) && $settings->carousel_item_number_original->lg) ? $settings->carousel_item_number_original->lg : 3;
        $carousel_item_number_md = (isset($settings->carousel_item_number_original->md) && $settings->carousel_item_number_original->md) ? $settings->carousel_item_number_original->md : 3;
        $carousel_item_number_sm = (isset($settings->carousel_item_number_sm) && $settings->carousel_item_number_sm) ? $settings->carousel_item_number_sm : 2;
        $carousel_item_number_xs = (isset($settings->carousel_item_number_xs) && $settings->carousel_item_number_xs) ? $settings->carousel_item_number_xs : 1;
        $carousel_bullet = (isset($settings->carousel_bullet) && $settings->carousel_bullet) ? $settings->carousel_bullet : 0;
        $content_alignment = (isset($settings->content_alignment) && $settings->content_alignment) ? $settings->content_alignment : '';

		//Arrow style
        $carousel_arrow = (isset($settings->carousel_arrow) && $settings->carousel_arrow) ? $settings->carousel_arrow : 0;
        $arrow_icon = (isset($settings->arrow_icon) && $settings->arrow_icon) ? $settings->arrow_icon : 'angle';
        $left_arrow ='';
        $right_arrow = '';
        if($arrow_icon=='long_arrow'){
            $left_arrow ='fa-long-arrow-left';
            $right_arrow = 'fa-long-arrow-right';
        } else {
			$left_arrow ='fa-angle-left';
            $right_arrow = 'fa-angle-right';
        }
        // Choose Layouts
        $review_layouts = (isset($settings->review_layouts) && $settings->review_layouts) ? $settings->review_layouts : 'default';

        //Quote icon
        $quote_icon = '';
        if(isset($settings->show_quote_icon) && $settings->show_quote_icon){
            $quote_icon .= '<div class="sppb-testimonial-carousel-icon">';
            $quote_icon .= '<i class="fa fa-quote-left" aria-hidden="true"></i>';
            $quote_icon .= '</div>';
        }

		//Output
		$output  = '<div class="sppb-addon sp-mf-customer-reviews sppb-carousel-extended '. $review_layouts . ' ' . $class . ' sppb-testimonial-carousel-'.$testimonial_carousel_layout.'" 
            data-left-arrow="'.$left_arrow.'" 
            data-right-arrow="'.$right_arrow.'" 
            data-arrow="'.$carousel_arrow.'" 
            data-dots="'.$carousel_bullet.'" 
            data-testi-layout="'.$testimonial_carousel_layout.'" 
            data-autoplay="'.$carousel_autoplay.'" 
            data-speed="'.$carousel_speed.'" 
            data-interval="'.$carousel_interval.'" 
            data-margin="'.$carousel_margin.'" 
            data-item-number-xxl="'.$carousel_item_number_xxl.'" 
            data-item-number-xl="'.$carousel_item_number_xl.'" 
            data-item-number-lg="'.$carousel_item_number_lg.'" 
            data-item-number-md="'.$carousel_item_number_md.'" 
            data-item-number-sm="'.$carousel_item_number_sm.'" 
            data-item-number-xs="'.$carousel_item_number_xs.'">';

		if(isset($settings->sp_testimonial_carousel_item) && is_array($settings->sp_testimonial_carousel_item)){
			foreach($settings->sp_testimonial_carousel_item as $item_key => $carousel_item){
                $uniqId = 'sppb-testi-'.$this->addon->id.'-carousel-item-key-'.$item_key;
                $client_details = '';
                
                $carousel_img = isset($carousel_item->testimonial_carousel_img) && $carousel_item->testimonial_carousel_img ? $carousel_item->testimonial_carousel_img : '';
                $carousel_img_src = isset($carousel_img->src) ? $carousel_img->src : $carousel_img;
                $brand_img = isset($carousel_item->testimonial_carousel_brand_img) && $carousel_item->testimonial_carousel_brand_img ? $carousel_item->testimonial_carousel_brand_img : '';
                $brand_img_src = isset($brand_img->src) ? $brand_img->src : $brand_img;
                
                $client_details .= '<div class="sppb-testimonial-carousel-content-wrap">';
                    if($carousel_img_src){
                        $client_details .= '<div class="sppb-testimonial-carousel-img-wrap">';
                        $client_details .= '<img src="'.$carousel_img_src.'" alt="'.(isset($carousel_item->client_name) ? $carousel_item->client_name : '').'">';
                        $client_details .= '</div>';
                    }
                    $client_details .= '<div class="sppb-testimonial-carousel-name-designation">';
                        if(isset($carousel_item->client_name)){
                            $client_details .= '<div class="sppb-testimonial-carousel-name">';
                            $client_details .= $carousel_item->client_name;
                            $client_details .= '</div>';
                        }
                        if(isset($carousel_item->client_desgination)){
                            $client_details .= '<div class="sppb-testimonial-carousel-designation">';
                            $client_details .= $carousel_item->client_desgination;
                            $client_details .= '</div>';
                        }
                    $client_details .= '</div>';
                $client_details .= '</div>';

                $rating = '';
                if(isset($carousel_item->show_rating) && $carousel_item->show_rating){
                    $rating .= '<div class="sppb-testimonial-carousel-client-rating rating-key-'. $item_key .'"><span class="sppb-testimonial-carousel-rating"></span></div>';
                }

                $output .= '<div id="'.$uniqId.'" class="sppb-carousel-extended-item'.' '.$content_alignment.'">';
                $output .= '<div class="d-flex content-wrap">';
                    if(strpos($brand_img_src, "http://") !== false || strpos($brand_img_src, "https://") !== false){
                        $output .= '<div class="review-brand-img" style="background-image: url('.$brand_img_src.');"></div>';
                    } else {
                        $output .= '<div class="review-brand-img" style="background-image: url('. JURI::base() .$brand_img_src.');"></div>';
                    }
                    $output .= '<div class="review-info">';
                    $output .= $quote_icon;
                    if($testimonial_carousel_layout == 'testi_layout1'){
                        $output .= $quote_icon;
                    }

                    if($testimonial_carousel_layout == 'testi_layout2'){
                        $output .= $client_details;
                    };

                    $output .= '<div class="sppb-testimonial-carousel-item-content">';
                    if(isset($carousel_item->client_message)){
                        $output .= '<div class="sppb-testimonial-carousel-message">';
                        $output .= $carousel_item->client_message;
                        $output .= '</div>';
                    }
                    $output .= '</div>';
                    if($testimonial_carousel_layout == 'testi_layout1' || $testimonial_carousel_layout == 'testi_layout3'){
                        $output .= $client_details;
                    };

                    if($testimonial_carousel_layout == 'testi_layout2'){
                        $output .= $quote_icon;
                    }
				$output .= '</div>'; //.review-info
				$output .= '</div>'; //.content-wrap
				$output .= '</div>'; //.sppb-carousel-extended-item
			}
		}
		$output .= '</div>';

		return $output;

	}

	public function scripts() {
		return array(JURI::base(true) . '/components/com_sppagebuilder/assets/js/sp_carousel.js');
	}

	public function css() {
		$settings = $this->addon->settings;
        $css = '';
        $addon_id = '#sppb-addon-' . $this->addon->id;
        $cssHelper = new CSSHelper($addon_id);

        $testimonial_carousel_layout = (isset($settings->testimonial_carousel_layout) && $settings->testimonial_carousel_layout) ? $settings->testimonial_carousel_layout : '';
        $overlay_gradient = (isset($settings->overlay_gradient) && $settings->overlay_gradient) ? $settings->overlay_gradient : '';
        
        //Arrow Style
        $carousel_arrow = (isset($settings->carousel_arrow) && $settings->carousel_arrow) ? $settings->carousel_arrow : 1;
        $arrow_style = '';
        // $arrow_style .= (isset($settings->arrow_height) && $settings->arrow_height) ? "height: " . $settings->arrow_height . "px;" : "";
        // $arrow_style .= (isset($settings->arrow_height) && $settings->arrow_height) ? "line-height: " . (((int) $settings->arrow_height)-((int) $settings->arrow_border_width)) . "px;" : "";

        // $arrow_style .= (isset($settings->arrow_width) && $settings->arrow_width) ? "width: " . $settings->arrow_width . "px;" : "";
        // $arrow_style .= (isset($settings->arrow_background) && $settings->arrow_background) ? "background: " . $settings->arrow_background . ";" : "";
        // $arrow_style .= (isset($settings->arrow_color) && $settings->arrow_color) ? "color: " . $settings->arrow_color . ";" : "";
        // $arrow_style .= (isset($settings->arrow_font_size) && $settings->arrow_font_size) ? "font-size: " . $settings->arrow_font_size . "px;" : "";
        // $arrow_style .= (isset($settings->arrow_border_width) && $settings->arrow_border_width) ? "border-width: " . $settings->arrow_border_width . "px;" : "";
        // $arrow_style .= (isset($settings->arrow_border_width) && $settings->arrow_border_width) ? "border-style: solid;" : "";
        // $arrow_style .= (isset($settings->arrow_border_color) && $settings->arrow_border_color) ? "border-color: " . $settings->arrow_border_color . ";" : "";
        // $arrow_style .= (isset($settings->arrow_border_radius) && $settings->arrow_border_radius) ? "border-radius: " . $settings->arrow_border_radius . "px;" : "";
        //Arrow hover style
        $arrow_hover_style = '';
        // $arrow_hover_style .= (isset($settings->arrow_hover_background) && $settings->arrow_hover_background) ? "background-color: " . $settings->arrow_hover_background . ";" : "";
        // $arrow_hover_style .= (isset($settings->arrow_hover_color) && $settings->arrow_hover_color) ? "color: " . $settings->arrow_hover_color . ";" : "";
        // $arrow_hover_style .= (isset($settings->arrow_hover_border_color) && $settings->arrow_hover_border_color) ? "border-color: " . $settings->arrow_hover_border_color . ";" : "";

        if($carousel_arrow) {
            $arrowStyleProps = [
                "arrow_height" => ["height", "line-height"],
                "arrow_width" => "width",
                "arrow_background" => "background",
                "arrow_color" => "color",
                "arrow_font_size" => "font-size",
                "arrow_border_width" => "border-style: solid;border-width",
                "arrow_border_color" => "border-color",
                "arrow_border_radius" => "border-radius",
                "arrow_position_verti" => "margin-top",
                "arrow_position_hori" => ["margin-left", "margin-right"],
            ];

            $arrowStyleUnits = [
                'arrow_background'    => false,
                'arrow_color'    => false,
                'arrow_border_color'    => false,
                'arrow_position_verti'    => "%",

            ];

           $css .= $cssHelper->generateStyle('.sppb-carousel-extended-nav-control .nav-control', $settings, $arrowStyleProps, $arrowStyleUnits);
            // if($arrow_style){
            //     $css .= $addon_id . ' .sppb-carousel-extended-nav-control .nav-control {';

            //         if(isset($settings->arrow_position_verti) && $settings->arrow_position_verti != ''){
            //             $css .= 'margin-top: '.$settings->arrow_position_verti.'%;';
            //         }
            //         if(isset($settings->arrow_position_hori) && $settings->arrow_position_hori != ''){
            //             $css .= 'margin-left: '.$settings->arrow_position_hori.'px;';
            //         }
            //         if(isset($settings->arrow_position_hori) && $settings->arrow_position_hori != ''){
            //             $css .= 'margin-right: '.$settings->arrow_position_hori.'px;';
            //         }
            //     $css .= '}';
            // }
            $arrowHoverStyleProps = [
                "arrow_hover_background" => "background-color",
                "arrow_hover_color" => "color",
                "arrow_hover_border_color" => "border-color",
            ];
            $css .= $cssHelper->generateStyle('.sppb-carousel-extended-nav-control .nav-control:hover', $settings, $arrowHoverStyleProps, false);
            // if($arrow_hover_style){
            //     $css .= $addon_id . ' .sppb-carousel-extended-nav-control .nav-control:hover{';
            //         $css .= $arrow_hover_style;
            //     $css .= '}';
            // }
        }
        //Bullet Style
        $carousel_bullet = (isset($settings->carousel_bullet) && $settings->carousel_bullet) ? $settings->carousel_bullet : 1;
        $bullet_style = '';
        // $bullet_style .= (isset($settings->bullet_height) && $settings->bullet_height) ? "height: " . $settings->bullet_height . "px;" : "";
        // $bullet_style .= (isset($settings->bullet_height) && $settings->bullet_height) ? "line-height: " . (($settings->bullet_height)-($settings->bullet_border_width)) . "px;" : "";

        // $bullet_style .= (isset($settings->bullet_width) && $settings->bullet_width) ? "width: " . $settings->bullet_width . "px;" : "";
        // $bullet_style .= (isset($settings->bullet_background) && $settings->bullet_background) ? "background: " . $settings->bullet_background . ";" : "";
        // $bullet_style .= (isset($settings->bullet_border_width) && $settings->bullet_border_width) ? "border-width: " . $settings->bullet_border_width . "px;" : "";
        // $bullet_style .= (isset($settings->bullet_border_width) && $settings->bullet_border_width) ? "border-style: solid;" : "";
        // $bullet_style .= (isset($settings->bullet_border_color) && $settings->bullet_border_color) ? "border-color: " . $settings->bullet_border_color . ";" : "";
        // $bullet_style .= (isset($settings->bullet_border_radius) && $settings->bullet_border_radius != '') ? "border-radius: " . $settings->bullet_border_radius . "px;" : "";
        //Bullet hover style
        $bullet_active_style = (isset($settings->bullet_active_background) && $settings->bullet_active_background) ? "background: " . $settings->bullet_active_background . ";" : "";

        if($carousel_bullet) {

            $bulletStyleProps = [
                "bullet_height" => ["height", "line-height"],
                "bullet_width" => "width",
                "bullet_background" => "background",
                "bullet_border_width" => "border-style: solid;border-width",
                "bullet_border_color" => "border-color",
                "bullet_border_radius" => "border-radius"
            ];

            $bulletStyleUnits = [
                'bullet_background'    => false,
                'bullet_border_width'    => false,
                'bullet_border_color'    => false,
            ];

            $css .= $cssHelper->generateStyle('.sppb-carousel-extended-dots ul li', $settings, $bulletStyleProps, $bulletStyleUnits);
            $css .= $cssHelper->generateStyle('.sppb-carousel-extended-dots', $settings, ["bullet_position_verti" => "bottom", "bullet_position_hori" => "left"], ["bullet_position_verti" => "%"]);

            // if($bullet_style) {
            //     $css .= $addon_id . ' .sppb-carousel-extended-dots ul li {';
            //         $css .= $bullet_style;
            //     $css .= '}';
            //     $css .= $addon_id . ' .sppb-carousel-extended-dots {';
            //         if(isset($settings->bullet_position_verti) && $settings->bullet_position_verti != ''){
            //             $css .= 'bottom: '.$settings->bullet_position_verti.'%;';
            //         }
            //         if(isset($settings->bullet_position_hori) && $settings->bullet_position_hori != ''){
            //             $css .= 'left: '.$settings->bullet_position_hori.'px;';
            //         }
            //     $css .= '}';
            // }

            $css .= $cssHelper->generateStyle('.sppb-carousel-extended-dots ul li:hover span, .sppb-carousel-extended-dots ul li.active span', $settings, ["bullet_active_background" => "background"], false);

            // if($bullet_active_style){
            //     $css .= $addon_id . ' .sppb-carousel-extended-dots ul li:hover span,';
            //     $css .= $addon_id . ' .sppb-carousel-extended-dots ul li.active span{';
            //         $css .= $bullet_active_style;
            //     $css .= '}';
            // }
        }

        //Avatar style
        $avatar_layout = (isset($settings->avatar_layout) && $settings->avatar_layout) ? $settings->avatar_layout : '';
        $settings->content_alignment = $cssHelper->parseAlignment($settings, 'content_alignment');
        $settings->content_alignment_wrap = $cssHelper->parseAlignment($settings, 'content_alignment', false);
        $margin = '';
        if ($testimonial_carousel_layout !== 'testi_layout3') {
            if ($avatar_layout == 'avatar_layout1') {
                $margin = 'margin-right';
            } elseif ($avatar_layout == 'avatar_layout2') {
                $margin = 'margin-left';
            } elseif ($avatar_layout == 'avatar_layout3') {
                $margin = 'margin-bottom';
            } elseif ($avatar_layout == 'avatar_layout4') {
                $margin = 'margin-top';
            }
        }

        $avatarStyleProps = [
            'avatar_height' => 'height',
            'avatar_width' => 'width',
            'avatar_gap' => $margin,
        ];

        $avatarStyle = $cssHelper->generateStyle('.sppb-testimonial-carousel-img-wrap', $settings, $avatarStyleProps);
        $css .= $avatarStyle;

        if (!empty($settings->content_alignment_wrap) && is_object($settings->content_alignment_wrap)) {
            $css .= $addon_id . ' .sppb-testimonial-carousel-img-wrap {';
            if ($settings->content_alignment_wrap->xl == "left" /*|| $settings->content_alignment_wrap->lg == "left" || $settings->content_alignment_wrap->md == "left" || $settings->content_alignment_wrap->sm == "left" || $settings->content_alignment_wrap->xs == "left"*/) {
                $css .= 'margin-right: auto;';
            } elseif ($settings->content_alignment_wrap->xl == "right" && $testimonial_carousel_layout == 'testi_layout3' && $avatar_layout != 'avatar_layout1'/*|| $settings->content_alignment_wrap->lg == "right" || $settings->content_alignment_wrap->md == "right" || $settings->content_alignment_wrap->sm == "right" || $settings->content_alignment_wrap->xs == "right"*/) {
                $css .= 'margin-left: auto;';
            } elseif ($settings->content_alignment_wrap->xl == "center" /*|| $settings->content_alignment_wrap->lg == "center" || $settings->content_alignment_wrap->md == "center" || $settings->content_alignment_wrap->sm == "center" || $settings->content_alignment_wrap->xs == "center"*/) {
                $css .= 'margin-left: auto;';
                $css .= 'margin-right: auto;';
            }
            $css .= '}';
        }

        $avatarBorderRadiusStyle = $cssHelper->generateStyle('.sppb-testimonial-carousel-img-wrap img', $settings, ['avatar_border_radius' => 'border-radius']);
        $css .= $avatarBorderRadiusStyle;

        if ($testimonial_carousel_layout == 'testi_layout3') {
            // $css .= $cssHelper->generateStyle('.sppb-testimonial-carousel-content-wrap', $settings, ['content_alignment_wrap' => 'align-items'], false);
            $css .= $addon_id . ' .sppb-testimonial-carousel-content-wrap {';
            $css .= 'align-items: initial;';
            $css .= 'flex-direction: column;';
            $css .= '}';
        } else {
            if ($avatar_layout == 'avatar_layout2') {
                $css .= $addon_id . ' .sppb-testimonial-carousel-content-wrap {';
                $css .= 'flex-direction: row-reverse;';
                $css .= '}';
                $css .= $addon_id . ' .sppb-testimonial-carousel-name-designation {';
                $css .= 'text-align: right;';
                $css .= '}';
            } elseif ($avatar_layout == 'avatar_layout3') {
                // $css .= $cssHelper->generateStyle('.sppb-testimonial-carousel-content-wrap', $settings, ['content_alignment_wrap' => 'align-items'], false);
                $css .= $addon_id . ' .sppb-testimonial-carousel-content-wrap {';
                $css .= 'align-items: initial;';
                $css .= 'flex-direction: column;';
                $css .= '}';
            } elseif ($avatar_layout == 'avatar_layout4') {
                // $css .= $cssHelper->generateStyle('.sppb-testimonial-carousel-content-wrap', $settings, ['content_alignment_wrap' => 'align-items'], false);
                $css .= $addon_id . ' .sppb-testimonial-carousel-content-wrap {';
                $css .= 'align-items: initial;';
                $css .= 'flex-direction: column-reverse;';
                $css .= '}';
            }

            if ($avatar_layout == 'avatar_layout1') {
                $css .= $addon_id . ' .sppb-testimonial-carousel-name-designation {';
                $css .= 'text-align: left;';
                $css .= '}';
            }
        }
        

        //Quote icon style
        if ($testimonial_carousel_layout == 'testi_layout1') {
            $margin = 'margin-bottom';
        } elseif ($testimonial_carousel_layout == 'testi_layout2') {
            $margin = 'margin-top';
        }

        $quoteStyleProps = [
            'quote_icon_size' => 'font-size',
            'quote_icon_color' => 'color',
            'quote_icon_gap' => $margin,
        ];

        $quoteStyleUnits = [
            'quote_icon_color' => false,
        ];

        $quoteStyle = $cssHelper->generateStyle('.sppb-testimonial-carousel-icon', $settings, $quoteStyleProps, $quoteStyleUnits);
        $css .= $quoteStyle;

        //Rating style
        // $rating_style = '';
        // $rating_style .= (isset($settings->rating_size) && $settings->rating_size) ? 'font-size:'.$settings->rating_size.'px;' : '';
        // $rating_style .= (isset($settings->rating_color) && $settings->rating_color) ? 'color:'.$settings->rating_color.';' : '';
        // if($testimonial_carousel_layout == 'testi_layout1' || $testimonial_carousel_layout == 'testi_layout3'){
        //     $rating_style .= (isset($settings->rating_gap) && $settings->rating_gap) ? 'margin-bottom:'.$settings->rating_gap.'px;' : '';
        // } elseif ($testimonial_carousel_layout == 'testi_layout2') {
        //     $rating_style .= (isset($settings->rating_gap) && $settings->rating_gap) ? 'margin-top:'.$settings->rating_gap.'px;' : '';
        // }
        // if($rating_style){
        //     $css .= $addon_id . ' .sppb-testimonial-carousel-rating{';
        //         $css .= $rating_style;
        //     $css .='}';
        // }

        // if(isset($settings->sp_testimonial_carousel_item) && is_array($settings->sp_testimonial_carousel_item)){
		// 	foreach($settings->sp_testimonial_carousel_item as $item_key => $carousel_item){
        //         $uniqId = '#sppb-testi-'.$this->addon->id.'-carousel-item-key-'.$item_key;
        //         if(isset($carousel_item->client_rating)){
        //             $css .= $uniqId.'.sppb-carousel-extended-item .sppb-testimonial-carousel-rating:before {';
        //                 $css .= 'width:'.((20 * $carousel_item->client_rating)-2).'%';
        //             $css .='}';
        //         }
        //     }
        // }

        //Rating style
        $marginRating = '';
        if ($testimonial_carousel_layout == 'testi_layout1' || $testimonial_carousel_layout == 'testi_layout3') {
            $marginRating = 'margin-bottom';
        } elseif ($testimonial_carousel_layout == 'testi_layout2') {
            $marginRating = 'margin-top';
        }
        $ratingStyle = $cssHelper->generateStyle('.sppb-testimonial-carousel-rating', $settings, ['rating_size' => 'font-size', 'rating_color' => 'color', 'rating_gap' => $marginRating], ['rating_color' => false]);

        $css .= $ratingStyle;

        if (isset($settings->sp_testimonial_carousel_item) && is_array($settings->sp_testimonial_carousel_item)) {
            foreach ($settings->sp_testimonial_carousel_item as $item_key => $carousel_item) {
                $uniqId = '#sppb-testi-' . $this->addon->id . '-carousel-item-key-' . $item_key;
                $css .= $uniqId . '.sppb-carousel-extended-item .sppb-testimonial-carousel-rating:before {';
                $css .= 'width:' . ((20 * isset( $carousel_item->client_rating)) - 2) . '%';
                $css .= '}';
            }
        }

        //Name style
        // $name_style = '';
        // $name_style .= (isset($settings->name_fontsize) && $settings->name_fontsize) ? 'font-size:'.$settings->name_fontsize.'px;' : '';
        // $name_style .= (isset($settings->name_lineheight) && $settings->name_lineheight) ? 'line-height:'.$settings->name_lineheight.'px;' : '';
        // $name_style .= (isset($settings->name_letterspace) && $settings->name_letterspace) ? 'letter-spacing:'.$settings->name_letterspace.';' : '';
        // $name_style .= (isset($settings->name_text_color) && $settings->name_text_color) ? 'color:'.$settings->name_text_color.';' : '';
        // $name_style .= (isset($settings->name_margin) && trim($settings->name_margin)) ? 'margin:'.$settings->name_margin.';' : '';
        
        // $name_font_style = (isset($settings->name_font_style) && $settings->name_font_style) ? $settings->name_font_style : '';
		// if(isset($name_font_style->underline) && $name_font_style->underline){
		// 	$name_style .= 'text-decoration:underline;';
		// }
		// if(isset($name_font_style->italic) && $name_font_style->italic){
		// 	$name_style .= 'font-style:italic;';
		// }
		// if(isset($name_font_style->uppercase) && $name_font_style->uppercase){
		// 	$name_style .= 'text-transform:uppercase;';
		// }
		// if(isset($name_font_style->weight) && $name_font_style->weight){
		// 	$name_style .= 'font-weight:'.$name_font_style->weight.';';
        // }
        
        // if($name_style){
        //     $css .= $addon_id . ' .sppb-testimonial-carousel-name {';
        //         $css .= $name_style;
        //     $css .='}';
        // }

        //Name style
        $nameTypographyStyle = $cssHelper->typography('.sppb-testimonial-carousel-name', $settings, 'name_typography', [
            'font'           => 'name_font_family',
            'size'           => 'name_fontsize',
            'line_height'    => 'name_lineheight',
            'letter_spacing' => 'name_letterspace',
            'uppercase'      => 'name_font_style.uppercase',
            'italic'         => 'name_font_style.italic',
            'underline'      => 'name_font_style.underline',
            'weight'         => 'name_font_style.weight',
        ]);

        $css .= $nameTypographyStyle;

        $nameStyle = $cssHelper->generateStyle('.sppb-testimonial-carousel-name', $settings, ['name_text_color' => 'color', 'name_margin' => 'margin'], ['name_text_color' => false, 'name_margin' => false]);
        $css .= $nameStyle;

        //Designation style
        // $designation_style = '';
        // $designation_style .= (isset($settings->designation_fontsize) && $settings->designation_fontsize) ? 'font-size:'.$settings->designation_fontsize.'px;' : '';
        // $designation_style .= (isset($settings->designation_lineheight) && $settings->designation_lineheight) ? 'line-height:'.$settings->designation_lineheight.'px;' : '';
        // $designation_style .= (isset($settings->designation_letterspace) && $settings->designation_letterspace) ? 'letter-spacing:'.$settings->designation_letterspace.';' : '';
        // $designation_style .= (isset($settings->designation_text_color) && $settings->designation_text_color) ? 'color:'.$settings->designation_text_color.';' : '';
        
        // $designation_font_style = (isset($settings->designation_font_style) && $settings->designation_font_style) ? $settings->designation_font_style : '';

		// if(isset($designation_font_style->underline) && $designation_font_style->underline){
		// 	$designation_style .= 'text-decoration:underline;';
		// }
		// if(isset($designation_font_style->italic) && $designation_font_style->italic){
		// 	$designation_style .= 'font-style:italic;';
		// }
		// if(isset($designation_font_style->uppercase) && $designation_font_style->uppercase){
		// 	$designation_style .= 'text-transform:uppercase;';
		// }
		// if(isset($designation_font_style->weight) && $designation_font_style->weight){
		// 	$designation_style .= 'font-weight:'.$designation_font_style->weight.';';
        // }
        
        // if($designation_style){
        //     $css .= $addon_id . ' .sppb-testimonial-carousel-designation {';
        //         $css .= $designation_style;
        //     $css .='}';
        // }

        $designationStyle = $cssHelper->generateStyle('.sppb-testimonial-carousel-designation', $settings, ['designation_text_color' => 'color'], false);
        $css .= $designationStyle;

        $designationTypographyStyle = $cssHelper->typography('.sppb-testimonial-carousel-designation ', $settings, 'title_typography', [
            'font' => 'designation_font_family',
            'size' => 'designation_fontsize',
            'line_height' => 'designation_lineheight',
            'letter_spacing' => 'designation_letterspace',
            'uppercase' => 'designation_font_style.uppercase',
            'italic' => 'designation_font_style.italic',
            'underline' => 'designation_font_style.underline',
            'weight' => 'designation_font_style.weight',
        ]);

        $css .= $designationTypographyStyle;

        //Message style
        // $message_style = '';
        // $message_style .= (isset($settings->message_fontsize) && $settings->message_fontsize) ? 'font-size:'.$settings->message_fontsize.'px;' : '';
        // $message_style .= (isset($settings->message_lineheight) && $settings->message_lineheight) ? 'line-height:'.$settings->message_lineheight.'px;' : '';
        // $message_style .= (isset($settings->message_letterspace) && $settings->message_letterspace) ? 'letter-spacing:'.$settings->message_letterspace.';' : '';
        // $message_style .= (isset($settings->message_text_color) && $settings->message_text_color) ? 'color:'.$settings->message_text_color.';' : '';
        // $message_style .= (isset($settings->message_margin_top) && trim($settings->message_margin_top)) ? 'margin-top:'.$settings->message_margin_top.'px;' : '';

        // if($testimonial_carousel_layout != 'testi_layout3'){
        //     $message_style .= (isset($settings->message_margin_bottom) && trim($settings->message_margin_bottom)) ? 'margin-bottom:'.$settings->message_margin_bottom.'px;' : '';
        // } else {
        //     $message_margin_bottom = (isset($settings->message_margin_bottom) && trim($settings->message_margin_bottom)) ? 'margin-bottom:'.$settings->message_margin_bottom.'px;' : '';
        //     $css .= $addon_id . ' .sppb-testimonial-carousel-item-content {';
        //         $css .= $message_margin_bottom;
        //         if(isset($settings->message_background) && $settings->message_background){
        //             $css .= 'background:'.$settings->message_background.';';
        //         }
        //         if(isset($settings->message_border_radius) && $settings->message_border_radius){
        //             $css .= 'border-radius:'.$settings->message_border_radius.'px;';
        //         }
        //         if(isset($settings->message_padding) && trim($settings->message_padding)) {
        //             $css .= 'padding:'.$settings->message_padding.';';
        //         };
        //     $css .='}';
        // }
        
        // $message_font_style = (isset($settings->message_font_style) && $settings->message_font_style) ? $settings->message_font_style : '';
		// if(isset($message_font_style->underline) && $message_font_style->underline){
		// 	$message_style .= 'text-decoration:underline;';
		// }
		// if(isset($message_font_style->italic) && $message_font_style->italic){
		// 	$message_style .= 'font-style:italic;';
		// }
		// if(isset($message_font_style->uppercase) && $message_font_style->uppercase){
		// 	$message_style .= 'text-transform:uppercase;';
		// }
		// if(isset($message_font_style->weight) && $message_font_style->weight){
		// 	$message_style .= 'font-weight:'.$message_font_style->weight.';';
        // }
        
        // if($message_style){
        //     $css .= $addon_id . ' .sppb-testimonial-carousel-message {';
        //         $css .= $message_style;
        //     $css .='}';
        // }

        // $arrow_height = (isset($settings->arrow_height) && $settings->arrow_height) ? $settings->arrow_height : '';
        // if($arrow_height){
        //     $css .= $addon_id . ' .sppb-carousel-extended-nav-control {';
        //         $css .= 'top: -'.$arrow_height.'px;';
        //     $css .='}';
        // }
        $itemContentProps = [
            'message_margin_bottom' => 'margin-bottom',
            'message_background' => ($testimonial_carousel_layout == 'testi_layout3') ? 'background' : null,
            'message_border_radius' => ($testimonial_carousel_layout == 'testi_layout3') ? 'border-radius' : null,
            'message_padding' => ($testimonial_carousel_layout == 'testi_layout3') ? 'padding' : null,
        ];

        $css .= $cssHelper->generateStyle('.sppb-testimonial-carousel-item-content', $settings, $itemContentProps, ['message_background' => false, 'message_padding' => false], ['message_padding' => 'spacing']);

        $messageStyleProps = [
            'message_text_color' => 'color',
            'message_margin_top' => 'margin-top',
            'message_margin_bottom' => ($testimonial_carousel_layout != 'testi_layout3') ? 'margin-bottom' : null,
        ];

        $messageStyleUnits = [
            'message_text_color' => false,
        ];

        $messageStyle = $cssHelper->generateStyle('.sppb-testimonial-carousel-message', $settings, $messageStyleProps, $messageStyleUnits);
        $css .= $messageStyle;

        $messageTypographyFallbacks = [
            'font' => 'message_font_family',
            'size' => 'message_fontsize',
            'line_height' => 'message_lineheight',
            'letter_spacing' => 'message_letterspace',
            'uppercase' => 'message_font_style.uppercase',
            'italic' => 'message_font_style.italic',
            'underline' => 'message_font_style.underline',
            'weight' => 'message_font_style.weight',
        ];

        $messageTypography = $cssHelper->typography('.sppb-testimonial-carousel-message', $settings, 'message_typography', $messageTypographyFallbacks);
        $css .= $messageTypography;

        $arrowHeightStyle = $cssHelper->generateStyle('.sppb-carousel-extended-nav-control', $settings, ['arrow_height' => 'top: -%s']);
        $css .= $arrowHeightStyle;

        //Item style
        // $item_style = '';
        // $item_style .= (isset($settings->content_background) && $settings->content_background) ? 'background:'.$settings->content_background.';' : '';
        // $item_style .= (isset($settings->content_padding) && trim($settings->content_padding)) ? 'padding:'.$settings->content_padding.';' : '';
        // $item_style .= (isset($settings->content_border_radius) && $settings->content_border_radius) ? 'border-radius:'.$settings->content_border_radius.'px;' : '';
        // if($item_style){
        //     $css .= $addon_id . ' .sppb-carousel-extended-item {';
        //         $css .= $item_style;
        //     $css .='}';
        // }
        $itemStyle = $cssHelper->generateStyle('.sppb-carousel-extended-item', $settings, ['content_alignment' => 'text-align', 'content_background' => 'background', 'content_padding' => 'padding', 'content_border_radius' => 'border-radius'], ['content_background' => false, 'content_padding' => false, 'content_alignment' => false], ['content_padding' => 'spacing']);
        $css .= $itemStyle;

        //Responsive tablet
        $name_style_sm = '';
        $name_style_sm .= (isset($settings->name_fontsize_sm) && $settings->name_fontsize_sm) ? 'font-size:'.$settings->name_fontsize_sm.'px;' : '';
        $name_style_sm .= (isset($settings->name_margin_sm) && trim($settings->name_margin_sm)) ? 'margin:'.$settings->name_margin_sm.';' : '';

        $designation_style_sm = '';
        $designation_style_sm .= (isset($settings->designation_fontsize_sm) && $settings->designation_fontsize_sm) ? 'font-size:'.$settings->designation_fontsize_sm.'px;' : '';

        $message_style_sm = '';
        $message_style_sm .= (isset($settings->message_fontsize_sm) && $settings->message_fontsize_sm) ? 'font-size:'.$settings->message_fontsize_sm.'px;' : '';
        $message_style_sm .= (isset($settings->message_lineheight_sm) && $settings->message_lineheight_sm) ? 'line-height:'.$settings->message_lineheight_sm.'px;' : '';
        $message_style_sm .= (isset($settings->message_margin_top_sm) && trim($settings->message_margin_top_sm)) ? 'margin-top:'.$settings->message_margin_top_sm.'px;' : '';

        if($testimonial_carousel_layout != 'testi_layout3'){
            $message_style_sm .= (isset($settings->message_margin_bottom_sm) && trim($settings->message_margin_bottom_sm)) ? 'margin-bottom:'.$settings->message_margin_bottom_sm.'px;' : '';
        }

        //Avatar tab style
        $avatar_style_sm = '';
        $avatar_style_sm .= (isset($settings->avatar_height_sm) && $settings->avatar_height_sm) ? 'height:'.$settings->avatar_height_sm.'px;' : '';
        $avatar_style_sm .= (isset($settings->avatar_width_sm) && $settings->avatar_width_sm) ? 'width:'.$settings->avatar_width_sm.'px;' : '';

        if($testimonial_carousel_layout !== 'testi_layout3') {
            if($avatar_layout == 'avatar_layout1'){
                $avatar_style_sm .= (isset($settings->avatar_gap_sm) && $settings->avatar_gap_sm) ? 'margin-right:'.$settings->avatar_gap_sm.'px;' : '';
            } elseif($avatar_layout == 'avatar_layout2'){
                $avatar_style_sm .= (isset($settings->avatar_gap_sm) && $settings->avatar_gap_sm) ? 'margin-left:'.$settings->avatar_gap_sm.'px;' : '';
            } elseif($avatar_layout == 'avatar_layout3'){
                $avatar_style_sm .= (isset($settings->avatar_gap_sm) && $settings->avatar_gap_sm) ? 'margin-bottom:'.$settings->avatar_gap_sm.'px;' : '';
            } elseif($avatar_layout == 'avatar_layout4'){
                $avatar_style_sm .= (isset($settings->avatar_gap_sm) && $settings->avatar_gap_sm) ? 'margin-top:'.$settings->avatar_gap_sm.'px;' : '';
            }
        }

        //Quote tab icon style
        $quote_style_sm = '';
        $quote_style_sm .= (isset($settings->quote_icon_size_sm) && $settings->quote_icon_size_sm) ? 'font-size:'.$settings->quote_icon_size_sm.'px;' : '';
        if($testimonial_carousel_layout == 'testi_layout1'){
            $quote_style_sm .= (isset($settings->quote_icon_gap_sm) && $settings->quote_icon_gap_sm) ? 'margin-bottom:'.$settings->quote_icon_gap_sm.'px;' : '';
        } elseif ($testimonial_carousel_layout == 'testi_layout2') {
            $quote_style_sm .= (isset($settings->quote_icon_gap_sm) && $settings->quote_icon_gap_sm) ? 'margin-top:'.$settings->quote_icon_gap_sm.'px;' : '';
        }

        //Rating tab style
        $rating_style_sm = '';
        $rating_style_sm .= (isset($settings->rating_size_sm) && $settings->rating_size_sm) ? 'font-size:'.$settings->rating_size_sm.'px;' : '';
        if($testimonial_carousel_layout == 'testi_layout1' || $testimonial_carousel_layout == 'testi_layout3'){
            $rating_style_sm .= (isset($settings->rating_gap_sm) && $settings->rating_gap_sm) ? 'margin-bottom:'.$settings->rating_gap_sm.'px;' : '';
        } elseif ($testimonial_carousel_layout == 'testi_layout2') {
            $rating_style_sm .= (isset($settings->rating_gap_sm) && $settings->rating_gap_sm) ? 'margin-top:'.$settings->rating_gap_sm.'px;' : '';
        }

        //Item style
        $item_style_sm = '';
        $item_style_sm .= (isset($settings->content_padding_sm) && trim($settings->content_padding_sm)) ? 'padding:'.$settings->content_padding_sm.';' : '';

        $css .= '@media (min-width: 768px) and (max-width: 991px) {';

            $css .= $addon_id . ' .sppb-carousel-extended-dots {';
                if(isset($settings->bullet_position_verti) && $settings->bullet_position_verti_sm){
                    $css .= 'bottom: '.$settings->bullet_position_verti_sm.'%;';
                }
                if(isset($settings->bullet_position_hori) && $settings->bullet_position_hori_sm){
                    $css .= 'left: '.$settings->bullet_position_hori_sm.'px;';
                }
            $css .= '}';
            $css .= $addon_id . ' .sppb-carousel-extended-nav-control .nav-control {';
                $css .= $arrow_style;
                if(isset($settings->arrow_position_verti) && $settings->arrow_position_verti_sm){
                    $css .= 'margin-top: '.$settings->arrow_position_verti_sm.'%;';
                }
                if(isset($settings->arrow_position_hori) && $settings->arrow_position_hori_sm){
                    $css .= 'margin-left: '.$settings->arrow_position_hori_sm.'px;';
                }
                if(isset($settings->arrow_position_hori) && $settings->arrow_position_hori_sm){
                    $css .= 'margin-right: '.$settings->arrow_position_hori_sm.'px;';
                }
            $css .= '}';

            if($name_style_sm){
                $css .= $addon_id . ' .sppb-testimonial-carousel-name {';
                    $css .= $name_style_sm;
                $css .='}';
            }
            if($designation_style_sm){
                $css .= $addon_id . ' .sppb-testimonial-carousel-designation {';
                    $css .= $designation_style_sm;
                $css .='}';
            }

            if($message_style_sm){
                $css .= $addon_id . ' .sppb-testimonial-carousel-message {';
                    $css .= $message_style_sm;
                $css .='}';
            }
            if($avatar_style_sm){
                $css .= $addon_id . ' .sppb-testimonial-carousel-img-wrap {';
                    $css .= $avatar_style_sm;
                $css .= '}';
            }
            if($quote_style_sm){
                $css .= $addon_id . ' .sppb-testimonial-carousel-icon {';
                    $css .= $quote_style_sm;
                $css .='}';
            }
            if($rating_style_sm){
                $css .= $addon_id . ' .sppb-testimonial-carousel-rating{';
                    $css .= $rating_style_sm;
                $css .='}';
            }
            if($testimonial_carousel_layout == 'testi_layout3'){
                $message_margin_bottom_sm = (isset($settings->message_margin_bottom_sm) && trim($settings->message_margin_bottom_sm)) ? 'margin-bottom:'.$settings->message_margin_bottom_sm.'px;' : '';
                $css .= $addon_id . ' .sppb-testimonial-carousel-item-content {';
                    $css .= $message_margin_bottom_sm;
                    if(isset($settings->message_padding_sm) && trim($settings->message_padding_sm)) {
                        $css .= 'padding:'.$settings->message_padding_sm.';';
                    };
                $css .='}';
            }
            if($item_style_sm){
                $css .= $addon_id . ' .sppb-carousel-extended-item {';
                    $css .= $item_style_sm;
                $css .='}';
            }

        $css .= '}';

        //Responsive mobile
        $name_style_xs = '';
        $name_style_xs .= (isset($settings->name_fontsize_xs) && $settings->name_fontsize_xs) ? 'font-size:'.$settings->name_fontsize_xs.'px;' : '';
        $name_style_xs .= (isset($settings->name_margin_xs) && trim($settings->name_margin_xs)) ? 'margin:'.$settings->name_margin_xs.';' : '';

        $designation_style_xs = '';
        $designation_style_xs .= (isset($settings->designation_fontsize_xs) && $settings->designation_fontsize_xs) ? 'font-size:'.$settings->designation_fontsize_xs.'px;' : '';

        $message_style_xs = '';
        $message_style_xs .= (isset($settings->message_fontsize_xs) && $settings->message_fontsize_xs) ? 'font-size:'.$settings->message_fontsize_xs.'px;' : '';
        $message_style_xs .= (isset($settings->message_lineheight_xs) && $settings->message_lineheight_xs) ? 'line-height:'.$settings->message_lineheight_xs.'px;' : '';
        $message_style_xs .= (isset($settings->message_margin_top_xs) && trim($settings->message_margin_top_xs)) ? 'margin-top:'.$settings->message_margin_top_xs.'px;' : '';
        if($testimonial_carousel_layout != 'testi_layout3'){
            $message_style_xs .= (isset($settings->message_margin_bottom_xs) && trim($settings->message_margin_bottom_xs)) ? 'margin-bottom:'.$settings->message_margin_bottom_xs.'px;' : '';
        }
        //Avatar tab style
        $avatar_style_xs = '';
        $avatar_style_xs .= (isset($settings->avatar_height_xs) && $settings->avatar_height_xs) ? 'height:'.$settings->avatar_height_xs.'px;' : '';
        $avatar_style_xs .= (isset($settings->avatar_width_xs) && $settings->avatar_width_xs) ? 'width:'.$settings->avatar_width_xs.'px;' : '';

        if($testimonial_carousel_layout !== 'testi_layout3') {
            if($avatar_layout == 'avatar_layout1'){
                $avatar_style_xs .= (isset($settings->avatar_gap_xs) && $settings->avatar_gap_xs) ? 'margin-right:'.$settings->avatar_gap_xs.'px;' : '';
            } elseif($avatar_layout == 'avatar_layout2'){
                $avatar_style_xs .= (isset($settings->avatar_gap_xs) && $settings->avatar_gap_xs) ? 'margin-left:'.$settings->avatar_gap_xs.'px;' : '';
            } elseif($avatar_layout == 'avatar_layout3'){
                $avatar_style_xs .= (isset($settings->avatar_gap_xs) && $settings->avatar_gap_xs) ? 'margin-bottom:'.$settings->avatar_gap_xs.'px;' : '';
            } elseif($avatar_layout == 'avatar_layout4'){
                $avatar_style_xs .= (isset($settings->avatar_gap_xs) && $settings->avatar_gap_xs) ? 'margin-top:'.$settings->avatar_gap_xs.'px;' : '';
            }
        }

        //Quote tab icon style
        $quote_style_xs = '';
        $quote_style_xs .= (isset($settings->quote_icon_size_xs) && $settings->quote_icon_size_xs) ? 'font-size:'.$settings->quote_icon_size_xs.'px;' : '';
        if($testimonial_carousel_layout == 'testi_layout1'){
            $quote_style_xs .= (isset($settings->quote_icon_gap_xs) && $settings->quote_icon_gap_xs) ? 'margin-bottom:'.$settings->quote_icon_gap_xs.'px;' : '';
        } elseif ($testimonial_carousel_layout == 'testi_layout2') {
            $quote_style_xs .= (isset($settings->quote_icon_gap_xs) && $settings->quote_icon_gap_xs) ? 'margin-top:'.$settings->quote_icon_gap_xs.'px;' : '';
        }

        //Rating tab style
        $rating_style_xs = '';
        $rating_style_xs .= (isset($settings->rating_size_xs) && $settings->rating_size_xs) ? 'font-size:'.$settings->rating_size_xs.'px;' : '';
        if($testimonial_carousel_layout == 'testi_layout1' || $testimonial_carousel_layout == 'testi_layout3'){
            $rating_style_xs .= (isset($settings->rating_gap_xs) && $settings->rating_gap_xs) ? 'margin-bottom:'.$settings->rating_gap_xs.'px;' : '';
        } elseif ($testimonial_carousel_layout == 'testi_layout2') {
            $rating_style_xs .= (isset($settings->rating_gap_xs) && $settings->rating_gap_xs) ? 'margin-top:'.$settings->rating_gap_xs.'px;' : '';
        }
        //Item style
        $item_style_xs = '';
        $item_style_xs .= (isset($settings->content_padding_xs) && trim($settings->content_padding_xs)) ? 'padding:'.$settings->content_padding_xs.';' : '';

        // $css .= '@media (max-width: 767px) {';

        //     $css .= $addon_id . ' .sppb-carousel-extended-dots {';
        //         if(isset($settings->bullet_position_verti) && $settings->bullet_position_verti_xs){
        //             $css .= 'bottom: '.$settings->bullet_position_verti_xs.'%;';
        //         }
        //         if(isset($settings->bullet_position_hori) && $settings->bullet_position_hori_xs){
        //             $css .= 'left: '.$settings->bullet_position_hori_xs.'px;';
        //         }
        //     $css .= '}';
        //     $css .= $addon_id . ' .sppb-carousel-extended-nav-control .nav-control {';
        //         $css .= $arrow_style;
        //         if(isset($settings->arrow_position_verti) && $settings->arrow_position_verti_xs){
        //             $css .= 'margin-top: '.$settings->arrow_position_verti_xs.'%;';
        //         }
        //         if(isset($settings->arrow_position_hori) && $settings->arrow_position_hori_xs){
        //             $css .= 'margin-left: '.$settings->arrow_position_hori_xs.'px;';
        //         }
        //         if(isset($settings->arrow_position_hori) && $settings->arrow_position_hori_xs){
        //             $css .= 'margin-right: '.$settings->arrow_position_hori_xs.'px;';
        //         }
        //     $css .= '}';

        //     if($name_style_xs){
        //         $css .= $addon_id . ' .sppb-testimonial-carousel-name {';
        //             $css .= $name_style_xs;
        //         $css .='}';
        //     }
        //     if($designation_style_xs){
        //         $css .= $addon_id . ' .sppb-testimonial-carousel-designation {';
        //             $css .= $designation_style_xs;
        //         $css .='}';
        //     }

        //     if($message_style_xs){
        //         $css .= $addon_id . ' .sppb-testimonial-carousel-message {';
        //             $css .= $message_style_xs;
        //         $css .='}';
        //     }

        //     if($avatar_style_xs){
        //         $css .= $addon_id . ' .sppb-testimonial-carousel-img-wrap {';
        //             $css .= $avatar_style_xs;
        //         $css .= '}';
        //     }
        //     if($quote_style_xs){
        //         $css .= $addon_id . ' .sppb-testimonial-carousel-icon {';
        //             $css .= $quote_style_xs;
        //         $css .='}';
        //     }
        //     if($rating_style_xs){
        //         $css .= $addon_id . ' .sppb-testimonial-carousel-rating{';
        //             $css .= $rating_style_xs;
        //         $css .='}';
        //     }
        //     if($testimonial_carousel_layout == 'testi_layout3'){
        //         $message_margin_bottom_xs = (isset($settings->message_margin_bottom_xs) && trim($settings->message_margin_bottom_xs)) ? 'margin-bottom:'.$settings->message_margin_bottom_xs.'px;' : '';
        //         $css .= $addon_id . ' .sppb-testimonial-carousel-item-content {';
        //             $css .= $message_margin_bottom_xs;
        //             if(isset($settings->message_padding_xs) && trim($settings->message_padding_xs)) {
        //                 $css .= 'padding:'.$settings->message_padding_xs.';';
        //             };
        //         $css .='}';
        //     }
        //     if($item_style_xs){
        //         $css .= $addon_id . ' .sppb-carousel-extended-item {';
        //             $css .= $item_style_xs;
        //         $css .='}';
        //     }

        // $css .= '}';

		return $css;
	}

	public static function getTemplate() {
        $lodash = new Lodash('#sppb-addon-{{ data.id }}');
        $output = '
		<style  type="text/css">';

        $output .= '<# if (data.carousel_arrow) { #>';
        $output .= $lodash->unit('margin-top', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_position_verti', '%');
        $output .= $lodash->unit('margin-left', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_position_hori', 'px');
        $output .= $lodash->unit('margin-right', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_position_hori', 'px');
        $output .= $lodash->unit('font-size', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_font_size', 'px', false);
        $output .= $lodash->unit('border-radius', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_border_radius', 'px', false);
        $output .= $lodash->unit('width', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_width', 'px', false);
        //normal
        $output .= $lodash->border('border-color', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_border_color');
        $output .= $lodash->color('color', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_color');
        $output .= $lodash->color('background-color', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_background');
        // hover
        $output .= $lodash->border('border-color', '.sppb-carousel-extended-nav-control .nav-control:hover', 'data.arrow_hover_border_color');
        $output .= $lodash->color('color', '.sppb-carousel-extended-nav-control .nav-control:hover', 'data.arrow_hover_color');
        $output .= $lodash->color('background-color', '.sppb-carousel-extended-nav-control .nav-control:hover', 'data.arrow_hover_background');
        $output .= '<# if (data.arrow_height) { #>';
        $output .= $lodash->unit('height', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_height', 'px', false);
        $output .= '<# let lineHeight = data.arrow_height - ((data.arrow_border_width != undefined) ? data.arrow_border_width : 0);#>';
        $output .= $lodash->unit('line-height', '.sppb-carousel-extended-nav-control .nav-control', 'lineHeight', 'px', false);
        $output .= '<# } #>';
        $output .= '<# if (data.arrow_border_width) { #>';
        $output .= $lodash->unit('border-width', '.sppb-carousel-extended-nav-control .nav-control', 'data.arrow_border_width', 'px', false);
        $output .= '#sppb-addon-{{ data.id }} .sppb-carousel-extended-nav-control .nav-control { border-style: solid; }';
        $output .= '<# } #>';
        $output .= $lodash->unit('top', '.sppb-carousel-extended-nav-control', 'data.arrow_height', 'px', false, '-');
        $output .= '<# } #>';

        // Bullet
        $output .= '<# if (data.carousel_bullet) { #>';
        $output .= $lodash->unit('bottom', '.sppb-carousel-extended-dots', 'data.bullet_position_verti', '%');
        $output .= $lodash->unit('left', '.sppb-carousel-extended-dots', 'data.bullet_position_hori', 'px');
        $output .= ' <# if (data.bullet_height) { #>';
        $output .= $lodash->unit('height', '.sppb-carousel-extended-dots ul li', 'data.bullet_height', 'px', false);
        $output .= $lodash->unit('line-height', '.sppb-carousel-extended-dots ul li', '(data.bullet_height)-(data.bullet_border_width)', 'px', false);
        $output .= '<# } #>';
        $output .= ' <# if (data.bullet_height) { #>';
        $output .= $lodash->unit('border-width', '.sppb-carousel-extended-dots ul li', 'data.bullet_border_width', 'px', false);
        //$output .= '#sppb-addon-{{ data.id }} .sppb-carousel-extended-dots ul li { border-style: solid; }';
        $output .= '<# } #>';
        $output .= $lodash->unit('border-radius', '.sppb-carousel-extended-dots ul li', 'data.bullet_border_radius', 'px', false);
        $output .= $lodash->unit('width', '.sppb-carousel-extended-dots ul li', 'data.bullet_width', 'px', false);
        $output .= $lodash->border('border-color', '.sppb-carousel-extended-dots ul li', 'data.bullet_border_color');
        $output .= $lodash->color('background-color', '.sppb-carousel-extended-dots ul li', 'data.bullet_background');
        $output .= $lodash->color('background-color', '.sppb-carousel-extended-dots ul li:hover span, .sppb-carousel-extended-dots ul li.active span', 'data.bullet_active_background');
        $output .= '<# } #>';

        $output .= $lodash->unit('border-radius', '.sppb-testimonial-carousel-item-content', 'data.content_border_radius', 'px');
        $output .= $lodash->unit('height', '.sppb-testimonial-carousel-img-wrap', 'data.avatar_height', 'px');
        $output .= $lodash->unit('width', '.sppb-testimonial-carousel-img-wrap', 'data.avatar_width', 'px');
        $output .= $lodash->unit('border-radius', '.sppb-testimonial-carousel-img-wrap img', 'data.avatar_border_radius', 'px', false);

        $output .= $lodash->unit('font-size', '.sppb-testimonial-carousel-icon', 'data.quote_icon_size', 'px');
        $output .= $lodash->color('color', '.sppb-testimonial-carousel-icon', 'data.quote_icon_color');

        $output .= $lodash->unit('font-size', '.sppb-testimonial-carousel-rating', 'data.rating_size', 'px');
        $output .= $lodash->color('color', '.sppb-testimonial-carousel-rating', 'data.rating_color');

        $output .= '<# if (data.testimonial_carousel_layout == "testi_layout1" &&  data.testimonial_carousel_layout == "testi_layout3") { #>';
        $output .= $lodash->unit('margin-bottom', '.sppb-testimonial-carousel-icon', 'data.quote_icon_gap', 'px');
        $output .= $lodash->unit('margin-bottom', '.sppb-testimonial-carousel-rating', 'data.quote_icon_gap', 'px');
        $output .= $lodash->unit('margin-bottom', '.sppb-testimonial-carousel-rating', 'data.rating_gap', 'px');
        $output .= '<# } #>';
        $output .= '<# if (data.testimonial_carousel_layout == "testi_layout2") { #>';
        $output .= $lodash->unit('margin-top', '.sppb-testimonial-carousel-icon', 'data.quote_icon_gap', 'px');
        $output .= $lodash->unit('margin-top', '.sppb-testimonial-carousel-rating', 'data.rating_gap', 'px');
        $output .= '<# } #>';

        $output .= '<# if (data.content_alignment == "sppb-text-left" || (_.isObject(data.content_alignment) && data.content_alignment.xl == "left")) {#>';
        $output .= '#sppb-addon-{{ data.id }} .sppb-testimonial-carousel-img-wrap { margin-right:auto;}';
        $output .= '<# } else if ((data.testimonial_carousel_layout != "testi_layout3" && data.avatar_layout == "avatar_layout1" && data.content_alignment == "sppb-text-right") || ((_.isObject(data.content_alignment) && data.content_alignment.xl == "right") && data.testimonial_carousel_layout != "testi_layout3" && data.avatar_layout == "avatar_layout1")) {#>';
        $output .= '#sppb-addon-{{ data.id }} .sppb-testimonial-carousel-img-wrap { margin-left:auto;}';
        $output .= '<# } else if ((data.testimonial_carousel_layout == "testi_layout3" && data.content_alignment == "sppb-text-right") || ((_.isObject(data.content_alignment) && data.content_alignment.xl == "right") && data.testimonial_carousel_layout == "testi_layout3")) {#>';
        $output .= '#sppb-addon-{{ data.id }} .sppb-testimonial-carousel-img-wrap { margin-left:auto;}';
        $output .= '<# } else if (data.content_alignment == "sppb-text-center" || (_.isObject(data.content_alignment) && data.content_alignment.xl == "center")) {#>';
        $output .= '#sppb-addon-{{ data.id }} .sppb-testimonial-carousel-img-wrap { margin-left:auto; margin-right:auto;}';
        $output .= '<# } #>';

        $output .= '<# if (data.testimonial_carousel_layout != "testi_layout3") { #>';
        $output .= '<# if (data.avatar_layout == "avatar_layout1") { #>';
        $output .= $lodash->unit('margin-right', '.sppb-testimonial-carousel-img-wrap', 'data.avatar_gap', 'px');
        $output .= '#sppb-addon-{{ data.id }} .sppb-testimonial-carousel-name-designation { text-align: left; }';
        $output .= '<# } #>';

        $output .= '<# if (data.avatar_layout == "avatar_layout2") { #>';
        $output .= $lodash->unit('margin-left', '.sppb-testimonial-carousel-img-wrap', 'data.avatar_gap', 'px');
        $output .= '#sppb-addon-{{ data.id }} .sppb-testimonial-carousel-content-wrap { flex-direction: row-reverse; }';
        $output .= '#sppb-addon-{{ data.id }} .sppb-testimonial-carousel-name-designation { text-align: right;}';
        $output .= '<# } #>';

        $output .= '<# if (data.avatar_layout == "avatar_layout3") { #>';
        $output .= $lodash->unit('margin-bottom', '.sppb-testimonial-carousel-img-wrap', 'data.avatar_gap', 'px');
        $output .= '#sppb-addon-{{ data.id }} .sppb-testimonial-carousel-content-wrap { align-items: initial; flex-direction: column;}';
        $output .= '<# } #>';

        $output .= '<# if (data.avatar_layout == "avatar_layout4") { #>';
        $output .= $lodash->unit('margin-top', '.sppb-testimonial-carousel-img-wrap', 'data.avatar_gap', 'px');
        $output .= '#sppb-addon-{{ data.id }} .sppb-testimonial-carousel-content-wrap { align-items: initial; flex-direction: column-reverse;}';
        $output .= '<# } #>';
        $output .= '<# } #>';

        $output .= '<# if (data.testimonial_carousel_layout == "testi_layout3") { #>';
        $output .= $lodash->unit('border-radius', '.sppb-testimonial-carousel-item-content', 'data.message_border_radius', 'px');
        $output .= $lodash->color('background-color', '.sppb-testimonial-carousel-item-content', 'data.message_background');
        $output .= $lodash->unit('margin-bottom', '.sppb-testimonial-carousel-item-content', 'data.message_margin_bottom', 'px');
        $output .= $lodash->spacing('padding', '.sppb-testimonial-carousel-item-content', 'data.message_padding');
        $output .= '#sppb-addon-{{ data.id }} .sppb-testimonial-carousel-content-wrap { align-items: initial; flex-direction: column;}';
        $output .= '<# } #>';

        $output .= $lodash->unit('margin-bottom', '.sppb-testimonial-carousel-message', 'data.message_margin_bottom', 'px');

        $nameTypographyFallbacks = [
            'font' => 'data.name_font_family',
            'size' => 'data.name_fontsize',
            'line_height' => 'data.name_lineheight',
            'letter_spacing' => 'data.name_letterspace',
            'uppercase' => 'data.name_font_style?.uppercase',
            'italic' => 'data.name_font_style?.italic',
            'underline' => 'data.name_font_style?.underline',
            'weight' => 'data.name_font_style?.weight',
        ];

        $output .= $lodash->typography('.sppb-testimonial-carousel-name', 'data.name_typography', $nameTypographyFallbacks);
        $output .= $lodash->color('color', '.sppb-testimonial-carousel-name', 'data.name_text_color');
        $output .= $lodash->spacing('margin', '.sppb-testimonial-carousel-name', 'data.name_margin');

        $messageTypographyFallbacks = [
            'font' => 'data.message_font_family',
            'size' => 'data.message_fontsize',
            'line_height' => 'data.message_lineheight',
            'letter_spacing' => 'data.message_letterspace',
            'uppercase' => 'data.message_font_style?.uppercase',
            'italic' => 'data.message_font_style?.italic',
            'underline' => 'data.message_font_style?.underline',
            'weight' => 'data.message_font_style?.weight',
        ];

        $output .= $lodash->typography('.sppb-testimonial-carousel-message', 'data.message_typography', $messageTypographyFallbacks);
        $output .= $lodash->color('color', '.sppb-testimonial-carousel-message', 'data.message_text_color');
        $output .= $lodash->unit('margin-top', '.sppb-testimonial-carousel-message', 'data.message_margin_top', 'px');
        $output .= $lodash->unit('margin-bottom', '.sppb-testimonial-carousel-message', 'data.message_margin_bottom', 'px');

        $titleTypographyFallbacks = [
            'font' => 'data.designation_font_family',
            'size' => 'data.designation_fontsize',
            'line_height' => 'data.designation_lineheight',
            'letter_spacing' => 'data.designation_letterspace',
            'uppercase' => 'data.designation_font_style?.uppercase',
            'italic' => 'data.designation_font_style?.italic',
            'underline' => 'data.designation_font_style?.underline',
            'weight' => 'data.designation_font_style?.weight',
        ];

        $output .= $lodash->typography('.sppb-testimonial-carousel-designation', 'data.title_typography', $titleTypographyFallbacks);
        $output .= $lodash->color('color', '.sppb-testimonial-carousel-designation', 'data.designation_text_color');

        $output .= $lodash->color('background-color', '.sppb-carousel-extended-item', 'data.content_background');
        $output .= $lodash->spacing('padding', '.sppb-carousel-extended-item', 'data.content_padding');
        $output .= $lodash->alignment('text-align', '.sppb-carousel-extended-item', 'data.content_alignment');

        $output .= '
			<# if(_.isArray(data.sp_testimonial_carousel_item)){
				_.each(data.sp_testimonial_carousel_item, function(carousel_item, caro_index){
					const uniqId = `#sppb-testi-${data.id}-carousel-item-key-${caro_index}`;
			#>
					{{uniqId}}.sppb-carousel-extended-item .sppb-testimonial-carousel-rating:before {
						width:{{(20 * carousel_item.client_rating)-2}}%;
					}
				<# })
			} #>
        </style>
        <#
		var left_arrow ="";
		var right_arrow = "";
		if(data.arrow_icon=="long_arrow"){
			left_arrow ="fa-long-arrow-left";
			right_arrow = "fa-long-arrow-right";
		} else {
			left_arrow ="fa-angle-left";
			right_arrow = "fa-angle-right";
		}

		let carousel_item_number_xxl = 3;
		let carousel_item_number_xl = 3;
		let carousel_item_number_lg = 3;
		let carousel_item_number_md = 3;
		let carousel_item_number_sm = 2;
		let carousel_item_number_xs = 1;
		if (_.isObject(data.carousel_item_number))
		{
			carousel_item_number_xxl = data.carousel_item_number.xxl
			carousel_item_number_xl = data.carousel_item_number.xl
			carousel_item_number_lg = data.carousel_item_number.lg
			carousel_item_number_md = data.carousel_item_number.md
			carousel_item_number_sm = data.carousel_item_number.sm
			carousel_item_number_xs = data.carousel_item_number.xs
		}

		let quote_icon = "";
		if (data.show_quote_icon)
		{
			quote_icon += `<div class="sppb-testimonial-carousel-icon">`;
			quote_icon += `<i class="fa fa-quote-left" aria-hidden="true"></i>`;
			quote_icon += `</div>`;
		}

		#>
			<div class="sppb-addon sp-mf-customer-reviews sppb-carousel-extended {{data.class}} sppb-testimonial-carousel-{{data.testimonial_carousel_layout}}"
				data-left-arrow="{{left_arrow}}"
				data-right-arrow="{{right_arrow}}"
				data-arrow="{{data.carousel_arrow}}"
				data-dots="{{data.carousel_bullet}}"
				data-testi-layout="{{data.testimonial_carousel_layout}}"
				data-autoplay="{{data.carousel_autoplay}}"
				data-speed="{{data.carousel_speed}}"
				data-interval="{{data.carousel_interval}}"
				data-margin="{{data.carousel_margin}}"
				data-item-number-xxl="{{carousel_item_number_xxl || 3}}"
				data-item-number-xl="{{carousel_item_number_xl || 3}}"
				data-item-number-lg="{{carousel_item_number_lg || 3}}"
				data-item-number-md="{{carousel_item_number_md || 3}}"
				data-item-number-sm="{{carousel_item_number_sm || 3}}"
				data-item-number-xs="{{carousel_item_number_xs || 1}}">
				<# if(_.isArray(data.sp_testimonial_carousel_item)){
					_.each(data.sp_testimonial_carousel_item, function(carousel_item, caro_index){
					const uniqId= `sppb-testi-${data.id}-carousel-item-key-${caro_index}`;
					let client_details = "";
					var carouselImg = {}
					if (typeof carousel_item.testimonial_carousel_img !== "undefined" && typeof carousel_item.testimonial_carousel_img.src !== "undefined") {
						carouselImg = carousel_item.testimonial_carousel_img
					} else {
						carouselImg = {src: carousel_item.testimonial_carousel_img}
					}
                    var brandImg = {}
                    if (typeof carousel_item.testimonial_carousel_brand_img !== "undefined" && typeof carousel_item.testimonial_carousel_brand_img.src !== "undefined") {
                        brandImg = carousel_item.testimonial_carousel_brand_img
                    } else {
                        brandImg = {src: carousel_item.testimonial_carousel_brand_img}
                    }
					client_details += `<div class="sppb-testimonial-carousel-content-wrap">`;
						if(carouselImg.src){
							client_details += `<div class="sppb-testimonial-carousel-img-wrap">`;
							client_details += `<img src=${carouselImg.src} alt=${carousel_item.client_name}>`;
							client_details += `</div>`;
						}
						client_details += `<div class="sppb-testimonial-carousel-name-designation">`;
							if(carousel_item.client_name){
								client_details += `<div class="sppb-testimonial-carousel-name">`;
								client_details += `${carousel_item.client_name}`;
								client_details += `</div>`;
							}
							if(carousel_item.client_desgination){
								client_details += `<div class="sppb-testimonial-carousel-designation">`;
								client_details += `${carousel_item.client_desgination}`;
								client_details += `</div>`;
							}
						client_details += `</div>`;
					client_details += `</div>`;

					let rating = "";
					if(carousel_item.show_rating){
						rating += `<div class="sppb-testimonial-carousel-client-rating"><span class="sppb-testimonial-carousel-rating"></span></div>`;
					}
				#>
						<div id="{{uniqId}}" class="sppb-carousel-extended-item {{data.content_alignment}}">
                            <div class="d-flex content-wrap">
                                <# if(brandImg.src){
                                    if(brandImg.src.indexOf("http://") == 0 || brandImg.src.indexOf("https://") == 0){ #>
                                        <div class="review-brand-img" style="background-image:url({{brandImg.src}});background-size:100% 100%;background-position:center center;background-attachment:scroll;background-repeat: no-repeat;"></div>
                                    <# } else { #>
                                        <div class="review-brand-img" style="background-image:url({{brandImg.src}});background-size:100% 100%;background-position:center center;background-attachment:scroll;background-repeat: no-repeat;"></div>
                                    <# }
                                } #>

                                

                                <# if(data.testimonial_carousel_layout == "testi_layout2"){
                                #>
                                    {{{client_details}}}
                                <# } #>

                                <div class="sppb-testimonial-carousel-item-content">
                                <# if(data.testimonial_carousel_layout == "testi_layout2" || data.testimonial_carousel_layout == "testi_layout3"){ #>
                                    {{{rating}}}
                                <# }

                                if(carousel_item.client_message) {
                                #>
                                    <div class="sppb-testimonial-carousel-message">
                                        {{carousel_item.client_message}}
                                    </div>
                                <# }

                                if(data.testimonial_carousel_layout == "testi_layout1"){
                                #>
                                    {{{rating}}}
                                <# } #>
                                </div>

                                <# if(data.testimonial_carousel_layout == "testi_layout1" || data.testimonial_carousel_layout == "testi_layout3"){ #>
                                    {{{client_details}}}
                                <# }

                                if(data.testimonial_carousel_layout == "testi_layout2"){
                                #>
                                    {{{quote_icon}}}
                                <# } #>
                            </div>
						</div>
					<#
					})
				} #>
			</div>
		';
        return $output;
    }
}